"""
Calculate the predicted values of y without the 
.predict method. Save your predictions in a list called 
my_y_pred. 

Hint: you will need the logistic function you defined 
in an earlier exercise
"""
import pandas as pd
import numpy as np

# setup (may already have this parth from lecture)
credit_data = pd.read_csv("default.csv")

from sklearn.linear_model import LogisticRegression

model = LogisticRegression() # make a LR model using the default settings
lr_fit = model.fit(X = credit_data[['balance']],
                   y = np.ravel(credit_data['default'])) 

#%%
my_y_pred = []
N = len(credit_data)

beta0 = lr_fit.intercept_[0] # y intercept
beta1 = lr_fit.coef_[0][0] # coefficient of balance


def logistic(a):
    return 1/(1 + np.exp(-a))

for i in range(N):
    x = credit_data.iloc[i]['balance']
    a = beta0 + beta1*x
    p = logistic(a)
    if p < 0.5:
        my_y_pred.append(0)
    else:
        my_y_pred.append(1)
    
my_y_pred = np.array(my_y_pred)

