"""
Calculate all four values of the confusion matrix

Hint: take advantage of boolean masks!
"""
import pandas as pd
import numpy as np

# setup (may already have this parth from lecture)
credit_data = pd.read_csv("default.csv")


from sklearn.linear_model import LogisticRegression

model = LogisticRegression() # make a LR model using the default settings
lr_fit = model.fit(X = credit_data[['balance']],
                   y = np.ravel(credit_data['default'])) 

y_data = credit_data['default'].values
y_pred = lr_fit.predict(credit_data['balance'].values.reshape(-1,1))

#%%

N = len(credit_data)
true_positive = sum( (y_data == 1) & (y_pred == 1))/N
true_negative = sum( (y_data == 0) & (y_pred == 0))/N
false_positive = sum( (y_data == 0) & (y_pred == 1))/N
false_negative = sum( (y_data == 1) & (y_pred == 0))/N

correct_rate = true_positive + true_negative
miclassif_rate = false_positive + false_negative
