"""
Redo the prediction using a different threshold
(higher or lower than 0.5)

Remember to break the data into test and training sets.
Then run your predictionon just the test data

Hint, you will need to modify your code from exercise 4
"""

import pandas as pd
import numpy as np

# setup (may already have this parth from lecture)
credit_data = pd.read_csv("default.csv")

from sklearn.linear_model import LogisticRegression
from sklearn.model_selection import train_test_split

model = LogisticRegression() # make a LR model using the default settings

X = credit_data[['balance', 'student']]
y_data = credit_data['default']
X_train, X_test, y_train, y_test = train_test_split(X, y_data, 
                                                    test_size=0.2, 
                                                    random_state=0)


lr_fit2 = model.fit(X = X_train, y = y_train) 

#%%

cutoff = 0.3 # lower than 0.5
my_y_pred = []
N = len(credit_data)

beta0 = lr_fit2.intercept_[0] # y intercept
beta1 = lr_fit2.coef_[0][0] # coefficient of balance
beta2 = lr_fit2.coef_[0][1] # coefficient of student


def logistic(a):
    return 1/(1 + np.exp(-a))

for i in range(len(X_test)):
    x = X_test.iloc[i][['balance', 'student']]
    a = beta0 + beta1*x[0] + beta2*x[1]
    p = logistic(a)
    if p < cutoff:
        my_y_pred.append(0)
    else:
        my_y_pred.append(1)
    
my_y_pred = np.array(my_y_pred)
sum(my_y_pred == y_test)/len(y_test)

#%%

my_y_pred.mean()