"""
Do some exploratory data analysis of the prog_data data set.

How may rows does it have?
What are the columns? 
 Read up on the column definitions if any column meanings
   are unclear: https://stats.idre.ucla.edu/sas/dae/multinomiallogistic-regression/
     
 What are the unique values of the program variable?
Find average math scores across the different programs
Find average math scores across the different socio-economic levels

"""
import pandas as pd

prog_data = pd.read_csv("hsbdemo.csv")

#%%
len(prog_data) # 200 rows
prog_data.columns
"""
 write, science, math, read are scores in those subjects
 ses is a 3-level socio-economic status
 prog is the type of program they choose
"""
prog_data['prog'].unique() # 'vocation', 'general', 'academic'


#%%
prog_data.groupby('prog').mean()['math']
prog_data.groupby('ses').mean()['math']
